import React from "react";
import { CommonAndHTMLProps, ShapeTypes, SpacingTypes } from "../Element/constants";
export interface BadgeCustomProps {
    size?: SpacingTypes;
    shape?: ShapeTypes;
    withDelete?: boolean;
    onDelete?: (event: React.MouseEvent<HTMLElement>) => void;
}
export type BadgeElementType = HTMLDivElement;
export type BadgeProps = Omit<CommonAndHTMLProps<BadgeElementType>, keyof BadgeCustomProps> & BadgeCustomProps;
export declare const Badge: React.ForwardRefExoticComponent<Omit<CommonAndHTMLProps<HTMLDivElement>, keyof BadgeCustomProps> & BadgeCustomProps & React.RefAttributes<HTMLDivElement>>;
