"use client";
import e, { useState as t, useRef as n, useEffect as r } from "react";
import { Div as a } from "../../Element/Tags.js";
import { InputField as o } from "../InputField/InputField.js";
import { Badge as l } from "../../Badge/Badge.js";
import { Text as i } from "../../Typography/Text.js";
import { BaseInputComponent as c } from "../BaseInputComponent/BaseInputComponent.js";
import { searchOptions as s } from "./listBoxUtils.js";
import "../../Element/Element.js";
import "../InputLabel/InputLabel.js";
import "../FormItem/FormItem.js";
var u = ["options", "label", "placeholder", "id", "allowMultiSelect", "onChange", "disabled", "badgeBgColour", "badgeBgColor", "badgeTextColour", "badgeTextColor", "selectionLimit", "allowCustomEntries"];
function m() {
  return m = Object.assign ? Object.assign.bind() : function(e2) {
    for (var t2 = 1; t2 < arguments.length; t2++) {
      var n2 = arguments[t2];
      for (var r2 in n2)
        Object.prototype.hasOwnProperty.call(n2, r2) && (e2[r2] = n2[r2]);
    }
    return e2;
  }, m.apply(this, arguments);
}
function p(e2) {
  return function(e3) {
    if (Array.isArray(e3))
      return b(e3);
  }(e2) || function(e3) {
    if ("undefined" != typeof Symbol && null != e3[Symbol.iterator] || null != e3["@@iterator"])
      return Array.from(e3);
  }(e2) || d(e2) || function() {
    throw new TypeError("Invalid attempt to spread non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }();
}
function f(e2, t2) {
  return function(e3) {
    if (Array.isArray(e3))
      return e3;
  }(e2) || function(e3, t3) {
    var n2 = null == e3 ? null : "undefined" != typeof Symbol && e3[Symbol.iterator] || e3["@@iterator"];
    if (null != n2) {
      var r2, a2, o2, l2, i2 = [], c2 = true, s2 = false;
      try {
        if (o2 = (n2 = n2.call(e3)).next, 0 === t3) {
          if (Object(n2) !== n2)
            return;
          c2 = false;
        } else
          for (; !(c2 = (r2 = o2.call(n2)).done) && (i2.push(r2.value), i2.length !== t3); c2 = true)
            ;
      } catch (e4) {
        s2 = true, a2 = e4;
      } finally {
        try {
          if (!c2 && null != n2.return && (l2 = n2.return(), Object(l2) !== l2))
            return;
        } finally {
          if (s2)
            throw a2;
        }
      }
      return i2;
    }
  }(e2, t2) || d(e2, t2) || function() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }();
}
function d(e2, t2) {
  if (e2) {
    if ("string" == typeof e2)
      return b(e2, t2);
    var n2 = Object.prototype.toString.call(e2).slice(8, -1);
    return "Object" === n2 && e2.constructor && (n2 = e2.constructor.name), "Map" === n2 || "Set" === n2 ? Array.from(e2) : "Arguments" === n2 || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n2) ? b(e2, t2) : void 0;
  }
}
function b(e2, t2) {
  (null == t2 || t2 > e2.length) && (t2 = e2.length);
  for (var n2 = 0, r2 = new Array(t2); n2 < t2; n2++)
    r2[n2] = e2[n2];
  return r2;
}
function v(e2, t2) {
  if (null == e2)
    return {};
  var n2, r2, a2 = function(e3, t3) {
    if (null == e3)
      return {};
    var n3, r3, a3 = {}, o3 = Object.keys(e3);
    for (r3 = 0; r3 < o3.length; r3++)
      n3 = o3[r3], t3.indexOf(n3) >= 0 || (a3[n3] = e3[n3]);
    return a3;
  }(e2, t2);
  if (Object.getOwnPropertySymbols) {
    var o2 = Object.getOwnPropertySymbols(e2);
    for (r2 = 0; r2 < o2.length; r2++)
      n2 = o2[r2], t2.indexOf(n2) >= 0 || Object.prototype.propertyIsEnumerable.call(e2, n2) && (a2[n2] = e2[n2]);
  }
  return a2;
}
var y = /* @__PURE__ */ e.forwardRef(function(d2, b2) {
  var y2 = d2.options, g = d2.label, h = d2.placeholder, x = void 0 === h ? "Select an option" : h, E = d2.id, w = d2.allowMultiSelect, C = void 0 !== w && w, j = d2.onChange, N = d2.disabled, k = d2.badgeBgColour, I = d2.badgeBgColor, O = d2.badgeTextColour, S = d2.badgeTextColor, D = d2.selectionLimit, A = d2.allowCustomEntries, B = void 0 !== A && A, L = v(d2, u), T = f(t(false), 2), F = T[0], P = T[1], M = f(t(null), 2), U = M[0], z = M[1], K = f(t([]), 2), q = K[0], H = K[1], R = f(t(""), 2), V = R[0], Y = R[1], $ = f(t(-1), 2), G = $[0], J = $[1], Q = n(), W = n(null), X = b2 || Q, Z = s(y2, V), _ = function(e2) {
    var t2;
    if (!e2.disabled)
      if (C) {
        if (q.some(function(t3) {
          return t3.value === e2.value;
        }))
          t2 = q.filter(function(t3) {
            return t3.value !== e2.value;
          });
        else {
          if (D && q.length >= D)
            return;
          t2 = [].concat(p(q), [e2]);
        }
        H(t2), null == j || j(t2.map(function(e3) {
          return e3.value;
        })), Y(""), J(-1);
      } else
        t2 = [e2], z(e2), H(t2), null == j || j(e2.value), P(false), Y(""), J(-1);
  }, ee = function(e2) {
    switch (e2.key) {
      case "ArrowDown":
        e2.preventDefault(), F ? J(function(e3) {
          return e3 < Z.length - 1 ? e3 + 1 : e3;
        }) : (P(true), J(0));
        break;
      case "ArrowUp":
        e2.preventDefault(), J(function(e3) {
          return e3 > 0 ? e3 - 1 : e3;
        });
        break;
      case "Enter":
        if (e2.preventDefault(), B && V.trim()) {
          var t2 = Z.find(function(e3) {
            return e3.label.toLowerCase() === V.trim().toLowerCase();
          });
          t2 ? _(t2) : function() {
            if (V.trim() && B) {
              var e3 = { value: V.trim(), label: V.trim() };
              _(e3), Y(""), J(-1);
            }
          }();
        } else
          G >= 0 && Z[G] && _(Z[G]);
        break;
      case "Escape":
        e2.preventDefault(), P(false), J(-1);
        break;
      case " ":
        F || (e2.preventDefault(), P(true), J(0));
        break;
      case "Home":
        F && (e2.preventDefault(), J(0));
        break;
      case "End":
        F && (e2.preventDefault(), J(Z.length - 1));
    }
  };
  return r(function() {
    var e2 = function(e3) {
      X.current && !X.current.contains(e3.target) && (P(false), J(-1));
    };
    return document.addEventListener("mousedown", e2), function() {
      return document.removeEventListener("mousedown", e2);
    };
  }, []), r(function() {
    F && W.current && W.current.focus();
  }, [F]), r(function() {
    if (G >= 0) {
      var e2 = document.querySelector('[data-index="'.concat(G, '"]'));
      null == e2 || e2.scrollIntoView({ block: "nearest" });
    }
  }, [G]), /* @__PURE__ */ e.createElement(c, m({ "data-list-box": true, className: "list-box-wrapper ".concat(N ? "disabled" : ""), "aria-disabled": N, ref: X }, L), g && /* @__PURE__ */ e.createElement("label", { id: "".concat(E, "-label"), htmlFor: "".concat(E, "-listbox"), className: "list-box-label" }, g), /* @__PURE__ */ e.createElement(a, { className: "list-box-input-wrapper", onClick: function() {
    return P(!F);
  }, onKeyDown: ee, "aria-haspopup": "listbox", "aria-expanded": F, "aria-labelledby": g ? "".concat(E, "-label") : void 0, "aria-controls": F ? "".concat(E, "-listbox") : void 0 }, C ? /* @__PURE__ */ e.createElement(e.Fragment, null, q.length > 0 ? /* @__PURE__ */ e.createElement(a, { className: "options-wrapper" }, /* @__PURE__ */ e.createElement(a, { className: "options-list" }, q.map(function(t2) {
    return e.createElement(l, { key: t2.value, withDelete: C, onDelete: function(e2) {
      return function(e3, t3) {
        e3.stopPropagation();
        var n2 = q.filter(function(e4) {
          return e4.value !== t3;
        });
        H(n2), null == j || j(n2.map(function(e4) {
          return e4.value;
        }));
      }(e2, t2.value);
    }, size: "small", shape: "rounded", bgColour: k || I, textColour: O || S }, t2.label);
  })), D && q.length >= D && /* @__PURE__ */ e.createElement(i, { className: "options-limit-warning", textColour: "red", size: "small" }, "You can choose only ", D, " option", 1 === D ? "" : "s")) : /* @__PURE__ */ e.createElement("span", { className: "placeholder" }, x), q.length > 0 && /* @__PURE__ */ e.createElement(a, { className: "icon-wrapper clear-all", title: "Clear all options", onClick: function(e2) {
    e2.stopPropagation(), H([]), null == j || j([]);
  } }, /* @__PURE__ */ e.createElement("svg", { viewBox: "0 0 24 24" }, /* @__PURE__ */ e.createElement("line", { x1: "5", y1: "5", x2: "19", y2: "19" }), /* @__PURE__ */ e.createElement("line", { x1: "5", y1: "19", x2: "19", y2: "5" })))) : U ? /* @__PURE__ */ e.createElement(i, { className: "selected-option" }, U.label) : /* @__PURE__ */ e.createElement("span", { className: "placeholder" }, x), /* @__PURE__ */ e.createElement(a, { className: "icon-wrapper chevrons" }, /* @__PURE__ */ e.createElement("svg", { viewBox: "0 0 24 24" }, /* @__PURE__ */ e.createElement("polyline", { points: "6 9 12 4 18 9" }), /* @__PURE__ */ e.createElement("polyline", { points: "6 15 12 20 18 15" })))), F && !N && /* @__PURE__ */ e.createElement(a, { className: "list-box-dropdown", role: "presentation" }, /* @__PURE__ */ e.createElement(a, { className: "list-box-search-wrapper" }, /* @__PURE__ */ e.createElement(o, { type: "text", ref: W, className: "list-box-search", placeholder: "Search", value: V, onChange: function(e2) {
    Y(e2.target.value);
  }, onKeyDown: ee, "aria-controls": "".concat(E, "-listbox") }), B && V.trim() && !q.some(function(e2) {
    return e2.label.toLowerCase() === V.trim().toLowerCase();
  }) && /* @__PURE__ */ e.createElement("kbd", { className: "list-box-enter-key" }, "↵")), /* @__PURE__ */ e.createElement("ul", { id: "".concat(E, "-listbox"), className: "list-box-options", role: "listbox", "aria-label": g || "Select options", tabIndex: -1 }, Z.length > 0 ? Z.map(function(t2, n2) {
    return e.createElement("li", { key: t2.value, id: "".concat(E, "-option-").concat(t2.value), className: "list-box-option ".concat(t2.disabled ? "disabled" : "", " ").concat(G === n2 ? "active" : ""), role: "option", "aria-selected": q.some(function(e2) {
      return e2.value === t2.value;
    }), "aria-disabled": t2.disabled, onClick: function() {
      return _(t2);
    }, "data-index": n2 }, t2.customLabel || t2.label);
  }) : /* @__PURE__ */ e.createElement("li", { className: "list-box-option disabled", role: "alert" }, "No matches found"))));
});
export {
  y as ListBox
};
